#include <linux/module.h>
#define INCLUDE_VERMAGIC
#include <linux/build-salt.h>
#include <linux/elfnote-lto.h>
#include <linux/export-internal.h>
#include <linux/vermagic.h>
#include <linux/compiler.h>

#ifdef CONFIG_UNWINDER_ORC
#include <asm/orc_header.h>
ORC_HEADER;
#endif

BUILD_SALT;
BUILD_LTO_INFO;

MODULE_INFO(vermagic, VERMAGIC_STRING);
MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

#ifdef CONFIG_RETPOLINE
MODULE_INFO(retpoline, "Y");
#endif

KSYMTAB_FUNC(nf_ct_nat_ext_add, "_gpl", "");
KSYMTAB_FUNC(nf_nat_setup_info, "", "");
KSYMTAB_FUNC(nf_nat_alloc_null_binding, "_gpl", "");
KSYMTAB_FUNC(nf_nat_packet, "_gpl", "");
KSYMTAB_FUNC(nf_nat_inet_fn, "_gpl", "");
KSYMTAB_FUNC(nf_nat_icmp_reply_translation, "_gpl", "");
KSYMTAB_FUNC(nf_nat_ipv4_register_fn, "_gpl", "");
KSYMTAB_FUNC(nf_nat_ipv4_unregister_fn, "_gpl", "");
KSYMTAB_FUNC(nf_nat_icmpv6_reply_translation, "_gpl", "");
KSYMTAB_FUNC(nf_nat_ipv6_register_fn, "_gpl", "");
KSYMTAB_FUNC(nf_nat_ipv6_unregister_fn, "_gpl", "");
KSYMTAB_FUNC(nf_nat_inet_register_fn, "_gpl", "");
KSYMTAB_FUNC(nf_nat_inet_unregister_fn, "_gpl", "");
KSYMTAB_FUNC(__nf_nat_mangle_tcp_packet, "", "");
KSYMTAB_FUNC(nf_nat_mangle_udp_packet, "", "");
KSYMTAB_FUNC(nf_nat_follow_master, "", "");
KSYMTAB_FUNC(nf_nat_exp_find_port, "_gpl", "");
KSYMTAB_FUNC(nf_nat_redirect_ipv4, "_gpl", "");
KSYMTAB_FUNC(nf_nat_redirect_ipv6, "_gpl", "");
KSYMTAB_FUNC(nf_nat_masquerade_ipv4, "_gpl", "");
KSYMTAB_FUNC(nf_nat_masquerade_ipv6, "_gpl", "");
KSYMTAB_FUNC(nf_nat_masquerade_inet_register_notifiers, "_gpl", "");
KSYMTAB_FUNC(nf_nat_masquerade_inet_unregister_notifiers, "_gpl", "");
KSYMTAB_FUNC(nf_ct_nat, "_gpl", "");

SYMBOL_CRC(nf_ct_nat_ext_add, 0x683b2c3c, "_gpl");
SYMBOL_CRC(nf_nat_setup_info, 0x0ea84261, "");
SYMBOL_CRC(nf_nat_alloc_null_binding, 0x3e0ee63c, "_gpl");
SYMBOL_CRC(nf_nat_packet, 0x78458a28, "_gpl");
SYMBOL_CRC(nf_nat_inet_fn, 0x6cde3e50, "_gpl");
SYMBOL_CRC(nf_nat_icmp_reply_translation, 0x1595c478, "_gpl");
SYMBOL_CRC(nf_nat_ipv4_register_fn, 0x37c2009e, "_gpl");
SYMBOL_CRC(nf_nat_ipv4_unregister_fn, 0x2e6beb2e, "_gpl");
SYMBOL_CRC(nf_nat_icmpv6_reply_translation, 0x82827777, "_gpl");
SYMBOL_CRC(nf_nat_ipv6_register_fn, 0x09e594df, "_gpl");
SYMBOL_CRC(nf_nat_ipv6_unregister_fn, 0x306bfc10, "_gpl");
SYMBOL_CRC(nf_nat_inet_register_fn, 0x3ac904bb, "_gpl");
SYMBOL_CRC(nf_nat_inet_unregister_fn, 0xc1f5f2db, "_gpl");
SYMBOL_CRC(__nf_nat_mangle_tcp_packet, 0x552d3b1f, "");
SYMBOL_CRC(nf_nat_mangle_udp_packet, 0x0928dbbc, "");
SYMBOL_CRC(nf_nat_follow_master, 0x389ed35e, "");
SYMBOL_CRC(nf_nat_exp_find_port, 0xb6baaf71, "_gpl");
SYMBOL_CRC(nf_nat_redirect_ipv4, 0x7f3836d1, "_gpl");
SYMBOL_CRC(nf_nat_redirect_ipv6, 0x04f818e2, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_ipv4, 0x8328a631, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_ipv6, 0x99cd2ca5, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_inet_register_notifiers, 0x3bc17c49, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_inet_unregister_notifiers, 0xd9c25654, "_gpl");
SYMBOL_CRC(nf_ct_nat, 0xdc8f6dc5, "_gpl");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0xbdfb6dbb, "__fentry__" },
	{ 0xad8f5963, "pskb_expand_head" },
	{ 0xe56957b6, "register_pernet_subsys" },
	{ 0x4b3fac7c, "nf_conntrack_tuple_taken" },
	{ 0x65487097, "__x86_indirect_thunk_rax" },
	{ 0xe8858c3f, "__raw_spin_lock_init" },
	{ 0x122c3a7e, "_printk" },
	{ 0xfac129aa, "nf_ct_iterate_cleanup_net" },
	{ 0xf0fdf6cb, "__stack_chk_fail" },
	{ 0x296695f, "refcount_warn_saturate" },
	{ 0xe609eb31, "_raw_spin_unlock_bh" },
	{ 0xb74e29ba, "ipv6_skip_exthdr" },
	{ 0x90a7082e, "nf_register_net_hooks" },
	{ 0xfe029963, "unregister_inetaddr_notifier" },
	{ 0x6383b27c, "__x86_indirect_thunk_rdx" },
	{ 0x36448ce, "module_put" },
	{ 0x4b3e082e, "ipv6_dev_get_saddr" },
	{ 0x33338211, "rcuref_get_slowpath" },
	{ 0x2469810f, "__rcu_read_unlock" },
	{ 0x8ffe7e89, "nf_conntrack_htable_size" },
	{ 0x1e4b18f1, "nf_ct_expect_related_report" },
	{ 0xebc55bb5, "ip_route_me_harder" },
	{ 0x98f103e8, "mutex_lock" },
	{ 0x80e108c9, "nf_hook_entries_delete_raw" },
	{ 0xd52b6202, "skb_ensure_writable" },
	{ 0x395fb4c6, "nf_unregister_net_hooks" },
	{ 0x5cd9ca6, "inet_select_addr" },
	{ 0x449ad0a7, "memcmp" },
	{ 0x460ec0f, "nf_ct_invert_tuple" },
	{ 0xe4fcdd26, "unregister_pernet_subsys" },
	{ 0x76bc36d5, "skb_checksum" },
	{ 0x2fe252cc, "unregister_inet6addr_notifier" },
	{ 0x5b8239ca, "__x86_return_thunk" },
	{ 0xf1db1704, "nla_memcpy" },
	{ 0x7009cb9, "nf_ct_delete" },
	{ 0xb47cca30, "csum_ipv6_magic" },
	{ 0x6b44092c, "nf_ip_checksum" },
	{ 0x4bfdf711, "register_btf_kfunc_id_set" },
	{ 0x1e1edae4, "nf_ct_iterate_destroy" },
	{ 0xe4262c6, "__siphash_unaligned" },
	{ 0x2d01c64c, "inet_proto_csum_replace16" },
	{ 0x9d0d6206, "unregister_netdevice_notifier" },
	{ 0x429e696b, "__put_net" },
	{ 0xb15b4109, "crc32c" },
	{ 0x44c10a52, "kvfree_call_rcu" },
	{ 0xb417c4b9, "__skb_checksum" },
	{ 0x7ed52728, "mutex_unlock" },
	{ 0xed062a3b, "inet_proto_csum_replace4" },
	{ 0x66b4cc41, "kmemdup" },
	{ 0x60352082, "register_inet6addr_notifier" },
	{ 0x2cf56265, "__dynamic_pr_debug" },
	{ 0xd2da1048, "register_netdevice_notifier" },
	{ 0x5089f45f, "ip_send_check" },
	{ 0xfac68fb2, "_raw_spin_lock_bh" },
	{ 0x3a92f124, "dst_release" },
	{ 0x2a702bfe, "nf_ct_kill_acct" },
	{ 0x289c3714, "nf_ct_alloc_hashtable" },
	{ 0x2cc8d5d2, "nf_nat_hook" },
	{ 0x41ed3709, "get_random_bytes" },
	{ 0xf68285c0, "register_inetaddr_notifier" },
	{ 0xfec64d23, "kmalloc_trace" },
	{ 0x83f51840, "__nla_parse" },
	{ 0x7aa1756e, "kvfree" },
	{ 0x7d5e1008, "__crc32c_le_shift" },
	{ 0x3866c129, "kmalloc_caches" },
	{ 0x18e60984, "__do_once_start" },
	{ 0x2d3385d3, "system_wq" },
	{ 0x609f1c7e, "synchronize_net" },
	{ 0x9bfbea78, "nf_ct_ext_add" },
	{ 0xc3d94ddf, "__do_once_done" },
	{ 0xabbcf7f8, "nf_conntrack_find_get" },
	{ 0xbddeaf99, "try_module_get" },
	{ 0xd542439, "__ipv6_addr_type" },
	{ 0x4f96e41b, "nf_ip6_checksum" },
	{ 0x1a55bbdc, "skb_copy_bits" },
	{ 0x9b4e4f30, "nf_hook_entries_insert_raw" },
	{ 0x2c19b726, "xfrm_lookup" },
	{ 0xfba7a5f5, "__get_random_u32_below" },
	{ 0x413bc91d, "nf_ct_seqadj_set" },
	{ 0xe5b5cefc, "skb_put" },
	{ 0x8d522714, "__rcu_read_lock" },
	{ 0xb0e602eb, "memmove" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0x8b569a7c, "nf_ct_helper_expectfn_unregister" },
	{ 0x78179797, "__xfrm_decode_session" },
	{ 0x89d99ee1, "__nf_ct_ext_find" },
	{ 0x5f8a4852, "nf_ct_helper_expectfn_register" },
	{ 0x69acdf38, "memcpy" },
	{ 0x37a0cba, "kfree" },
	{ 0x35b11056, "_raw_read_unlock_bh" },
	{ 0xbf919a59, "_raw_read_lock_bh" },
	{ 0x44f0ad9, "get_random_u16" },
	{ 0x68eb35f7, "ip6_route_me_harder" },
	{ 0x3b08a8f0, "nf_ct_destroy" },
	{ 0x98d20656, "module_layout" },
};

MODULE_INFO(depends, "nf_conntrack,libcrc32c");


MODULE_INFO(srcversion, "776F92A39BF9ED5BA4C1140");

MODULE_INFO(suserelease, "openSUSE Tumbleweed");
